#include <iostream>

using namespace std;
int dp[701][701][701];
int a[200007];
int psum[200007];
// 1,1
// 1,2


int parti(int l, int r, int k) {
    if (k == 0) {
        if (!l) {
            dp[l][r][k] = psum[r];
            return psum[r];
        }
        else {
            dp[l][r][k] = psum[r]-psum[l-1];
            return psum[r]-psum[l-1];
        }
    }
    int result = 0;
    for (int i = l; i <= r; i++) {
        for (int j = i; j <= r; j++) {
            if (dp[i][j][k-1] != 0)
                result += dp[i][j][k-1];
            else result += parti(i, j, k - 1);
        }
    }
    dp[l][r][k] = result;
    return result;
}

int main()
{
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (!i) psum[i] = a[i];
        else psum[i] = a[i] + psum[i-1];
    }
    cout << parti(0,n-1, k);
    return 0;
}
// C = 2
// 01010100000010101010101010011010